Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 10302)
@@ -271,5 +271,5 @@
       zn_dms_srf(:,:)  = 0.0
       za_dms_srf(:,:)  = 0.0
-      zn_chl_srf(:,:)  = 2.0E-8 !! Chl srf
+      zn_chl_srf(:,:)  = 2.0E-8 !! Chl cpl - set first as surf
       !!
       IF(lwp) WRITE(numout,*) ' trc_ini_medusa: DMS and CO2 flux (UKESM) initialised to zero'
@@ -278,5 +278,5 @@
          CO2Flux_out_cpl(:,:) =  zn_co2_flx(:,:)   !! Coupling variable
          DMS_out_cpl(:,:)     =  zn_dms_srf(:,:)   !! Coupling variable
-         chloro_out_cpl(:,:)  =  zn_chl_srf(:,:)   !! Coupling variable
+         chloro_out_cpl(:,:)  =  zn_chl_srf(:,:) * scl_chl   !! Coupling variable
       END IF
       !!
@@ -324,4 +324,14 @@
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
       IF(lwp) CALL flush(numout)
+      !!
+      !!----------------------------------------------------------------------
+      !! JPALM (23-01-2017): new way to initialize CO2-atm for cmip6 
+      !!                     initially done in trcsms_medusa
+      !!----------------------------------------------------------------------
+      !! 
+      IF( ( .NOT.lk_oasis ) .AND. ( .NOT.lk_pi_co2 ) .AND. ( xobs_xco2a <= 0.0 ) ) THEN
+         IF(lwp) WRITE(numout,*) ' trc_ini_medusa: initialisating atm CO2 record'
+         CALL trc_ini_medusa_co2atm
+      ENDIF
 
    END SUBROUTINE trc_ini_medusa
@@ -480,4 +490,88 @@
    END SUBROUTINE trc_ini_medusa_river
    
+   SUBROUTINE trc_ini_medusa_co2atm
+      !!----------------------------------------------------------------------
+      !!                     ***  trc_ini_medusa_co2atm  ***  
+      !!
+      !! ** Purpose :   initialization atmospheric co2 record
+      !!
+      !! ** Method  : - Read the xco2 file
+      !!----------------------------------------------------------------------
+      INTEGER                       ::  jn, jm, io, ierr, inum, iostatus
+      INTEGER, PARAMETER            ::  iskip = 4   ! number of 1st descriptor lines
+      REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:)   ::   zyy !: xCO2 record years
+      CHARACTER (len=10), PARAMETER ::  clname = 'xco2.atm'  !! atm CO2 record file
+      !!----------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' trc_ini_medusa_co2atm: initialisation of atm CO2 historical record'
+      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~'
+
+
+      IF(lwp) WRITE(numout,*) 'read of formatted file xco2.atm'
+
+      CALL ctl_opn( inum, clname, 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
+      !!!
+      ! -Compute the number of year in the file
+      ! -File starts in co2_yinit, jn represents the record number in the file.
+      ! -Remove the file head (iskip lines) to jn
+      ! -The year is jn + yinit - 1 
+      !! Determine the number of lines in xCO2 input file
+      iostatus = 0
+      jn = 1
+      DO WHILE ( iostatus == 0 )
+        READ(inum,'(1x)', IOSTAT=iostatus, END=100)
+        jn = jn + 1
+      ENDDO
+      IF( iostatus .NE. 0 ) THEN
+        !! Error while reading xCO2 input file 
+        CALL ctl_stop('trc_ini_medusa_co2atm: &
+                      & Error on the 1st reading of xco2.atm')
+        RETURN
+      ENDIF
+ 100  co2_rec = jn - 1 - iskip
+      IF ( lwp) WRITE(numout,*) '    ', co2_rec ,' years read in the file'
+      !                                ! Allocate CO2 hist arrays
+      ierr = 0 
+      ALLOCATE( hist_pco2(co2_rec),zyy(co2_rec), STAT=ierr )
+      IF( ierr > 0 ) THEN
+         CALL ctl_stop( 'trc_ini_medusa_co2atm: unable to allocate  array' )  
+         RETURN
+      ENDIF
+
+      REWIND(inum)
+
+      DO jm = 1, iskip        ! Skip over 1st six descriptor lines
+         READ(inum,'(1x)')
+      END DO
+      ! file starts in 1931 do jn represent the year in the century.jhh
+      ! Read file till the end
+      ! allocate start and end year of the file
+      DO jn = 1, co2_rec
+        READ(inum,'(F6.1,F12.7)', IOSTAT=io) zyy(jn), hist_pco2(jn)
+        IF( io .NE. 0 ) THEN
+          !! Error while reading xCO2 input file 
+          CALL ctl_stop('trc_ini_medusa_co2atm: &
+                        & Error on the 2nd reading of xco2.atm')
+          RETURN
+        ENDIF
+
+        IF(jn==1) co2_yinit = zyy(jn)
+      END DO
+      co2_yend = co2_yinit + real(co2_rec) - 1.
+
+      IF(lwp) THEN        ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'CO2 hist start year: ', co2_yinit
+         WRITE(numout,*) 'CO2 hist end   year: ', co2_yend
+         WRITE(numout,*) ' Year   xCO2 atm '
+         DO jn = 1, co2_rec
+            WRITE(numout, '(F6.1,F12.7)') zyy(jn), hist_pco2(jn)
+         END DO
+      ENDIF
+
+   END SUBROUTINE trc_ini_medusa_co2atm
+
+
 #else
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 10302)
@@ -24,4 +24,5 @@
    USE sms_medusa      ! sms trends
    USE iom             ! I/O manager
+   USE sbc_oce, ONLY: lk_oasis
    !!USE trc_nam_dia     ! JPALM 13-11-2015 -- if iom_use for diag
 
@@ -85,7 +86,10 @@
       &  jriver_n,jriver_si,jriver_c,jriver_alk,jriver_dep,   &
       &  xsdiss,                                              &
-      &  sedlam,sedlostpoc,jpkb,jdms,jdms_input,jdms_model
+      &  sedlam,sedlostpoc,jpkb,jdms,jdms_input,jdms_model,   &
+      &  scl_chl, chl_out, dmsmin, dmscut, dmsslp,            &
+      &  ln_foam_medusa
 #if defined key_roam
       NAMELIST/natroam/ xthetaphy,xthetazoo,xthetanit,        &
+      &    xobs_xco2a,                                        &
       &    xthetarem,xo2min 
 #endif
@@ -125,4 +129,6 @@
       ! 1.4 namelist natbio : biological parameters
       ! -------------------------------------------
+      !! Note: the default values below will all be overwritten by the
+      !!       input in the namelist natbio.
       
       xxi         = 0.
@@ -246,4 +252,11 @@
       jdms_input  = 0
       jdms_model  = 0
+      scl_chl     = 1.
+      chl_out     = 1
+      dmsmin      = 2.29 !! Anderson DMS default
+      dmscut      = 1.72 !! Anderson DMS default
+      dmsslp      = 8.24 !! Anderson DMS default
+!!
+      ln_foam_medusa = .FALSE.
             
       !REWIND(numnatm)
@@ -399,5 +412,15 @@
 !!       jdms_model  :  choice of DMS model passed to atmosphere
 !!                      1 = ANDR, 2 = SIMO, 3 = ARAN, 4 = HALL, 5 = ANDM
-!!
+!!       dmsmin      : DMS minimum value for DMS Anderson (ANDR) sheme ONLY
+!!       dmscut      : DMS cutoff value for DMS Anderson (ANDR) sheme ONLY
+!!       dmsslp      : DMS slope value for DMS Anderson (ANDR) sheme ONLY
+!! UKESM1 - exported Chl to UM
+!!       scl_chl     : scaling factor to tune the chl field sent to the UM
+!!       chl_out     : select the chl field to send at the UM:
+!!                     1- Surf Chl ; 2- MLD Chl 
+!!
+!! FOAM - observation operator and data assimilation
+!!       ln_foam_medusa : calculate required diagnostics
+
       IF(lwp) THEN
 !!
@@ -909,30 +932,58 @@
 !!
 !! UKESM1 - new diagnostics  !! Jpalm; AXY (08/07/15)
-         WRITE(numout,*) '=== UKESM1-related parameters'
-         WRITE(numout,*)     &
-         &   ' include DMS diagnostic?,                                   jdms        = ', jdms
-         if (jdms_input .eq. 0) then
-            WRITE(numout,*)     &
-            &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = instantaneous'
-         else
-            WRITE(numout,*)     &
-            &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = diel-average'
-         endif
-	 if (jdms_model .eq. 1) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Anderson et al. (2001)'
-	 elseif (jdms_model .eq. 2) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Simo & Dachs (2002)'
-	 elseif (jdms_model .eq. 3) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Aranami & Tsunogai (2004)'
-	 elseif (jdms_model .eq. 4) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Halloran et al. (2010)'
-	 elseif (jdms_model .eq. 5) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Anderson et al. (2001; modified)'
-         endif
+         WRITE(numout,*) '=== UKESM1-related parameters ==='
+         WRITE(numout,*) ' ---- --- ---'
+
+         IF (lk_oasis) THEN
+            WRITE(numout,*) '=== UKESM1 --  coupled DMS to the atmosphere'
+            WRITE(numout,*)     &
+            &   ' include DMS diagnostic?,                                   jdms        = ', jdms
+            if (jdms_input .eq. 0) then
+               WRITE(numout,*)     &
+               &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = instantaneous'
+            else
+               WRITE(numout,*)     &
+               &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = diel-average'
+            endif
+   	    if (jdms_model .eq. 1) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Anderson et al. (2001)'
+	    elseif (jdms_model .eq. 2) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Simo & Dachs (2002)'
+	    elseif (jdms_model .eq. 3) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Aranami & Tsunogai (2004)'
+	    elseif (jdms_model .eq. 4) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Halloran et al. (2010)'
+	    elseif (jdms_model .eq. 5) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Anderson et al. (2001; modified)'
+            endif
+            if (jdms_model .eq. 1) then
+               WRITE(numout,*)     &
+               &   ' Anderson DMS model tuned parameters:                       DMS minimum = ',dmsmin,'. -- Default = 2.29 '
+               WRITE(numout,*)     &
+               &   ' Anderson DMS model tuned parameters:                       DMS cutoff  = ',dmscut,'. -- Default = 1.72 '
+               WRITE(numout,*)     &
+               &   ' Anderson DMS model tuned parameters:                       DMS slope   = ',dmsslp,'. -- Default = 8.24 '
+            endif
+
+            WRITE(numout,*) '=== UKESM1 --  coupled Chl to the atmosphere'
+            WRITE(numout,*)        &
+               &   ' Scaling factor to export tuned Chl to the atmosphere       scl_chl  = ', scl_chl
+            IF (chl_out .eq. 1) THEN
+               WRITE(numout,*)        &
+               &   ' Chl field to be scaled and sent to the atmosphere:         chl_out  = Surface Chl field '
+            ELSEIF (chl_out .eq. 2) THEN
+               WRITE(numout,*)        &
+               &   ' Chl field to be scaled and sent to the atmosphere:         chl_out  = MLD Chl field '
+            ENDIF
+         ENDIF ! IF lk_oasis=true
+!! FOAM
+         WRITE(numout,*) '=== FOAM-related parameters'
+         WRITE(numout,*)     &
+         &   ' calculate diagnostics for data assimilation,            ln_foam_medusa = ', ln_foam_medusa
 !!
       ENDIF
@@ -990,4 +1041,5 @@
       xthetarem = 0.
       xo2min    = 0.
+      xobs_xco2a = 0.
 
       !READ(numnatm,natroam)
@@ -1009,4 +1061,5 @@
 !!       xthetarem :  oxygen consumption by carbon remineralisation
 !!       xo2min    :  oxygen minimum concentration
+!!       xobs_xco2a : observed atmospheric xCO2 (not used if <= 0)
 
       IF(lwp) THEN
@@ -1026,4 +1079,6 @@
           WRITE(numout,*)     &
           &   ' oxygen minimum concentration                               xo2min      = ', xo2min
+          WRITE(numout,*)     &
+          &   ' observed atmospheric xCO2 (not used if <= 0)               xobs_xco2a  = ', xobs_xco2a
        ENDIF
 
@@ -2053,5 +2108,16 @@
           med_diag%OCN_DPCO2%dgsave = .FALSE.
       ENDIF
-      !!
+      !! UKESM additional
+      IF  (iom_use("CHL_MLD")) THEN 
+          med_diag%CHL_MLD%dgsave = .TRUE.
+      ELSE 
+          med_diag%CHL_MLD%dgsave = .FALSE.
+      ENDIF
+      IF  (iom_use("CHL_CPL")) THEN 
+          med_diag%CHL_CPL%dgsave = .TRUE.
+      ELSE 
+          med_diag%CHL_CPL%dgsave = .FALSE.
+      ENDIF
+      !! 3D
       IF  (iom_use("TPP3")) THEN 
           med_diag%TPP3%dgsave = .TRUE.
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsms_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsms_medusa.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsms_medusa.F90	(revision 10302)
@@ -8,4 +8,5 @@
    !!              -   !  2008-11  (A. Yool) continuing adaptation for MEDUSA
    !!              -   !  2010-03  (A. Yool) updated for branch inclusion
+   !!              -   !  2017-08  (A. Yool) amend for slow detritus bug
    !!----------------------------------------------------------------------
 #if defined key_medusa
@@ -22,4 +23,9 @@
    USE trcsed_medusa
    USE trcavg_medusa
+   !! for SMS trends
+   USE par_medusa,    ONLY: jp_msa0, jp_msa1, jp_medusa
+   USE par_oce,       ONLY: jpi, jpj, jpk
+   USE trd_oce,       ONLY: jptra_sms, l_trdtrc
+   USE trdtrc
 
 
@@ -46,4 +52,9 @@
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) :: kt   ! ocean time-step index
+      !! Loop variables
+      INTEGER :: jn
+      !! trend temporary array:
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztrmed
+
 
 # if defined key_debug_medusa
@@ -57,4 +68,13 @@
        IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
       ENDIF
+
+      !! MEDUSA SMS trends:
+      IF( l_trdtrc ) THEN
+          CALL wrk_alloc( jpi, jpj, jpk, jp_medusa, ztrmed )
+          ztrmed(:,:,:,:)=0.0  
+          DO jn = 1, jp_medusa
+            ztrmed(:,:,:,jn) = tra(:,:,:,jp_msa0 + jn - 1)
+          END DO
+      END IF
 
       CALL trc_avg_medusa( kt ) ! rolling average module
@@ -88,10 +108,21 @@
 #  endif
       
-      CALL trc_sed_medusa( kt ) ! sedimentation model
-#  if defined key_debug_medusa
-      IF(lwp) WRITE(numout,*) ' MEDUSA done trc_sed_medusa'
-      CALL flush(numout)
-#  endif
+!! AXY (08/08/2017): remove call to buggy subroutine (now handled by detritus.F90)
+!!       CALL trc_sed_medusa( kt ) ! sedimentation model
+!! #  if defined key_debug_medusa
+!!       IF(lwp) WRITE(numout,*) ' MEDUSA done trc_sed_medusa'
+!!       CALL flush(numout)
+!! #  endif
 # endif
+
+      !! MEDUSA SMS trends:
+      IF( l_trdtrc ) THEN
+          DO jn = 1, jp_medusa
+            ztrmed(:,:,:,jn) = tra(:,:,:,jp_msa0 + jn - 1)-ztrmed(:,:,:,jn)
+            CALL trd_trc( ztrmed(:,:,:,jn), jn, jptra_sms, kt )   ! save trends
+          END DO
+          CALL wrk_dealloc( jpi, jpj, jpk, jp_medusa, ztrmed )
+      END IF
+
 
    END SUBROUTINE trc_sms_medusa
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/zooplankton.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/zooplankton.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/MEDUSA/zooplankton.F90	(revision 10302)
@@ -41,5 +41,8 @@
                                    idf, idfval,                          &
                                    zdet, zdtc, zphd, zphn, zzme, zzmi
-      USE dom_oce,           ONLY: e3t_0, e3t_n, tmask
+      USE dom_oce,           ONLY: e3t_0, tmask
+#if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n
+#endif
       USE par_kind,          ONLY: wp
       USE in_out_manager,    ONLY: lwp, numout
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl.F90	(revision 10302)
@@ -51,7 +51,9 @@
       !!
       !!----------------------------------------------------------------------  
+      IMPLICIT NONE
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step 
       CHARACTER (len=22) :: charout
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::   ztrtrd
+      INTEGER :: jn                   ! Local loop index
       !!----------------------------------------------------------------------
       !
@@ -108,4 +110,6 @@
 CONTAINS
    SUBROUTINE trc_bbl( kt )              ! Empty routine
+      IMPLICIT NONE
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
       WRITE(*,*) 'tra_bbl: You should not have seen this print! error?', kt
    END SUBROUTINE trc_bbl
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 10302)
@@ -27,7 +27,9 @@
    !!----------------------------------------------------------------------
    USE oce_trc         ! ocean dynamics and tracers variables
+   USE domvvl          ! variable volume  
    USE trc             ! ocean passive tracers variables
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE prtctl_trc      ! Print control for debbuging
+   USE trcnam_trp      ! passive tracers transport namelist variables
    USE trd_oce
    USE trdtra
@@ -45,4 +47,6 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::   r2dt
 
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
@@ -124,5 +128,37 @@
       IF( l_trdtrc )  THEN
          CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrdt )  !* store now fields before applying the Asselin filter
-         ztrdt(:,:,:,:)  = trn(:,:,:,:)
+         ztrdt(:,:,jpk,:) = 0._wp
+         IF( ln_trcldf_iso ) THEN                       ! diagnose the "pure" Kz diffusive trend 
+            DO jn = 1, jptra
+               CALL trd_tra( kt, 'TRC', jn, jptra_zdfp, ztrdt(:,:,:,jn) )
+            ENDDO
+         ENDIF
+         ! total trend for the non-time-filtered variables.
+         ! G Nurser 23 Mar 2017. Recalculate trend as Delta(e3t*T)/e3tn; e3tn
+         ! cancel from tsn terms
+         IF( lk_vvl ) THEN
+            DO jn = 1, jptra
+               DO jk = 1, jpkm1
+                  zfact = 1.0 / rdttrc(jk)
+                  ztrdt(:,:,jk,jn) = ( tra(:,:,jk,jn)*fse3t_a(:,:,jk) / fse3t_n(:,:,jk) - &
+                                       trn(:,:,jk,jn) ) * zfact
+               END DO
+            END DO
+         ELSE
+            DO jn = 1, jptra
+               DO jk = 1, jpkm1
+                  zfact = 1.0 / rdttrc(jk)
+                  ztrdt(:,:,jk,jn) = ( tra(:,:,jk,jn) - trn(:,:,jk,jn) ) * zfact
+               END DO
+            END DO
+         END IF
+         DO jn = 1, jptra
+            CALL trd_tra( kt, 'TRC', jn, jptra_tot, ztrdt(:,:,:,jn) )
+         ENDDO
+         IF( .NOT.lk_vvl )  THEN
+            ! Store now fields before applying the Asselin filter 
+            ! in order to calculate Asselin filter trend later.
+            ztrdt(:,:,:,:)  = trn(:,:,:,:)
+         ENDIF
       ENDIF
       ! Leap-Frog + Asselin filter time stepping
@@ -134,4 +170,15 @@
             END DO
          END DO
+         IF (l_trdtrc.AND.lk_vvl) THEN      ! Zero Asselin filter contribution
+                                            ! must be explicitly written out since for vvl
+                                            ! Asselin filter is output by
+                                            ! tra_nxt_vvl that is not called on
+                                            ! this time step
+            ztrdt(:,:,:,:) = 0._wp
+            DO jn = 1, jptra
+               CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt(:,:,:,jn) )
+            ENDDO
+         END IF
+
          !                                              
       ELSE
@@ -144,14 +191,15 @@
 
       ! trends computation
-      IF( l_trdtrc ) THEN                                      ! trends
+      IF( l_trdtrc.AND..NOT.lk_vvl) THEN                                      ! trends
          DO jn = 1, jptra
             DO jk = 1, jpkm1
                zfact = 1.e0 / r2dt(jk)  
                ztrdt(:,:,jk,jn) = ( trb(:,:,jk,jn) - ztrdt(:,:,jk,jn) ) * zfact 
-               CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt )
-            END DO
+            END DO
+            CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt(:,:,:,jn) )
          END DO
-         CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrdt ) 
       END IF
+      !
+      IF( l_trdtrc)  CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrdt ) 
       !
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 10302)
@@ -140,6 +140,9 @@
       DO jn = 1, jptra
          !
-         IF( l_trdtrc ) ztrtrd(:,:,:) = tra(:,:,:,jn)  ! save trends
-         !                                             ! add the trend to the general tracer trend
+         IF( l_trdtrc ) THEN
+            ztrtrd(:,:,:) = 0.0
+            ztrtrd(:,:,1) = tra(:,:,1,jn)  ! save surface trends
+         !                                 ! add the trend to the general tracer trend
+         ENDIF
 
          IF ( nn_ice_tr == -1 ) THEN  ! No tracers in sea ice (null concentration in sea ice)
@@ -184,5 +187,5 @@
          !
          IF( l_trdtrc ) THEN
-            ztrtrd(:,:,:) = tra(:,:,:,jn) - ztrtrd(:,:,:)
+            ztrtrd(:,:,1) = tra(:,:,1,jn) - ztrtrd(:,:,1)
             CALL trd_tra( kt, 'TRC', jn, jptra_nsr, ztrtrd )
          END IF
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 10302)
@@ -28,5 +28,5 @@
    USE zpshde          ! partial step: hor. derivative       (zps_hde routine)
 # if defined key_debug_medusa
-   USE trcrst
+   USE trcstat
 # endif
 
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 10302)
@@ -15,4 +15,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc         ! ocean dynamics and active tracers
+   USE domvvl          ! variable volume       
    USE trc             ! ocean passive tracers variables
    USE trcnam_trp      ! passive tracers transport namelist variables
@@ -98,8 +99,21 @@
 
       IF( l_trdtrc )   THEN                      ! save the vertical diffusive trends for further diagnostics
+         !! JPALM -- 18-08-2017 -- vvl case, do as done by G Nurser in trazdf 
+         IF( lk_vvl ) THEN
+            DO jn = 1, jptra
+               DO jk = 1, jpkm1
+                  ztrtrd(:,:,jk,jn) = ( ( tra(:,:,jk,jn)*fse3t_a(:,:,jk) - &
+                                          trb(:,:,jk,jn)*fse3t_b(:,:,jk) ) &
+                                       / (fse3t_n(:,:,jk)*r2dt(jk)) ) - ztrtrd(:,:,jk,jn)
+               END DO
+            END DO
+         ELSE
+            DO jn = 1, jptra
+               DO jk = 1, jpkm1
+                  ztrtrd(:,:,jk,jn) = ( ( tra(:,:,jk,jn) - trb(:,:,jk,jn) ) / r2dt(jk) ) - ztrtrd(:,:,jk,jn)
+               END DO
+            END DO
+         ENDIF 
          DO jn = 1, jptra
-            DO jk = 1, jpkm1
-               ztrtrd(:,:,jk,jn) = ( ( tra(:,:,jk,jn) - trb(:,:,jk,jn) ) / r2dt(jk) ) - ztrtrd(:,:,jk,jn)
-            END DO
             CALL trd_tra( kt, 'TRC', jn, jptra_zdf, ztrtrd(:,:,:,jn) )
          END DO
